/*
 The MIT License (MIT)

 Copyright (c) 2014 Irrelon Software Limited
 http://www.irrelon.com

 Permission is hereby granted, free of charge, to any person obtaining a copy
 of this software and associated documentation files (the "Software"), to deal
 in the Software without restriction, including without limitation the rights
 to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the Software is
 furnished to do so, subject to the following conditions:

 The above copyright notice, url and this permission notice shall be included in
 all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 THE SOFTWARE.

 Source: https://github.com/irrelon/jquery-lang-js

 Changelog: See readme.md
 */
var Lang=function(){var t=function(){this._fireEvents=!0,this._dynamic={}};return t.prototype.init=function(t){var e,a,n,i,o=this;(t=t||{}).cookie=t.cookie||{},a=t.defaultLang,n=t.currentLang,i=t.allowCookieOverride,this.cookieName=t.cookie.name||"langCookie",this.cookieExpiry=t.cookie.expiry||365,this.cookiePath=t.cookie.path||"/",this._mutationCopies={append:$.fn.append,appendTo:$.fn.appendTo,prepend:$.fn.prepend,before:$.fn.before,after:$.fn.after,html:$.fn.html},$.fn.append=function(){return o._mutation(this,"append",arguments)},$.fn.appendTo=function(){return o._mutation(this,"appendTo",arguments)},$.fn.prepend=function(){return o._mutation(this,"prepend",arguments)},$.fn.before=function(){return o._mutation(this,"before",arguments)},$.fn.after=function(){return o._mutation(this,"after",arguments)},$.fn.html=function(){return o._mutation(this,"html",arguments)},this.defaultLang=a||"en",this.currentLang=a||"en",!i&&n||!Cookies||(e=Cookies.get(this.cookieName))&&(n=e),$(function(){o._start(),n&&n!==o.defaultLang&&o.change(n)})},t.prototype.pack={},t.prototype.attrList=["title","alt","placeholder","href"],t.prototype.dynamic=function(t,e){t!==undefined&&e!==undefined&&(this._dynamic[t]=e)},t.prototype.loadPack=function(i,o){var r=this;if(!i||!r._dynamic[i])throw"Cannot load language pack, no file path specified!";$.ajax({dataType:"json",url:r._dynamic[i],success:function(t){if(r.pack[i]=t,r.pack[i].regex){var e,a,n=r.pack[i].regex;for(a=0;a<n.length;a++)2===(e=n[a]).length?e[0]=new RegExp(e[0]):3===e.length&&(e[0]=new RegExp(e[0],e[1]),e.splice(1,1))}o&&o(!1,i,r._dynamic[i])},error:function(){throw o&&o(!0,i,r._dynamic[i]),"Error loading language pack"+r._dynamic[i]}})},t.prototype._start=function(t){for(var e,a=t!==undefined?$(t).find("[lang]"):$(":not(html)[lang]"),n=a.length;n--;)e=$(a[n]),this._processElement(e)},t.prototype._processElement=function(t){t.attr("lang")===this.defaultLang&&(this._storeAttribs(t),this._storeContent(t))},t.prototype._storeAttribs=function(t){var e,a,n;for(e=0;e<this.attrList.length;e++)a=this.attrList[e],t.attr(a)&&((n=t.data("lang-attr")||{})[a]=t.attr(a),t.data("lang-attr",n))},t.prototype._storeContent=function(t){if(t.is("input"))switch(t.attr("type")){case"button":case"submit":case"hidden":case"reset":t.data("lang-val",t.val())}else if(t.is("img"))t.data("lang-src",t.attr("src"));else{var e=this._getTextNodes(t);e&&t.data("lang-text",e)}},t.prototype._getTextNodes=function(t){var e=t.contents(),a=[],n={};Array.prototype.map;return $.each(e,function(t,e){3===e.nodeType&&(n={node:e,langDefaultText:e.data},a.push(n))}),a},t.prototype._setTextNodes=function(t,e,a){var n,i,o,r,s=a!==this.defaultLang;for(n=0;n<e.length;n++)if(i=e[n],s){if(o=$.trim(i.langDefaultText))if(r=this.translate(o,a))try{i.node.data=i.node.data.split($.trim(i.node.data)).join(r)}catch(c){}else console&&console.log&&console.log('Translation for "'+o+'" not found!')}else try{i.node.data=i.langDefaultText}catch(c){}},t.prototype._translateAttribs=function(t,e){var a,n,i=t.data("lang-attr")||{};for(a in i)i.hasOwnProperty(a)&&t.attr(a)&&(e!==this.defaultLang?(n=this.translate(i[a],e))&&t.attr(a,n):t.attr(a,i[a]))},t.prototype._translateContent=function(t,e){var a,n,i=e!==this.defaultLang;if(t.is("input"))switch(t.attr("type")){case"button":case"submit":case"hidden":case"reset":i?(a=this.translate(t.data("lang-val"),e))&&t.val(a):t.val(t.data("lang-val"))}else t.is("img")?i?(a=this.translate(t.data("lang-src"),e))&&t.attr("src",a):t.attr("src",t.data("lang-src")):(n=t.data("lang-text"))&&this._setTextNodes(t,n,e)},t.prototype.change=function(n,i,o){var r=this;if(n!==this.defaultLang&&!this.pack[n]&&!this._dynamic[n])throw o&&o("No language pack defined for: "+n,n,i),'Attempt to change language to "'+n+'" but no language pack for that language is loaded!';if(n!==this.defaultLang){if(!this.pack[n]&&this._dynamic[n])return void this.loadPack(n,function(t,e,a){t?o&&o("Language pack could not load from: "+a,n,i):r.change.call(r,n,i,o)});if(!this.pack[n]&&!this._dynamic[n])throw o&&o("Language pack not defined for: "+n,n,i),"Could not change language to "+n+" because no language pack for this language exists!"}var t=!1,e=this.currentLang;this.currentLang!=n&&(this.beforeUpdate(e,n),t=!0),this.currentLang=n;for(var a,s=i!==undefined?$(i).find("[lang]"):$(":not(html)[lang]"),c=s.length;c--;)(a=$(s[c])).attr("lang")!==n&&this._translateElement(a,n);t&&this.afterUpdate(e,n),Cookies&&Cookies.set(r.cookieName,n,{expires:r.cookieExpiry,path:r.cookiePath}),o&&o(!1,n,i)},t.prototype._translateElement=function(t,e){this._translateAttribs(t,e),"false"!=t.attr("data-lang-content")&&this._translateContent(t,e),t.attr("lang",e)},t.prototype.translate=function(t,e){if(e=e||this.currentLang,this.pack[e]){var a="";return e!=this.defaultLang?((a=this.pack[e].token[t])||(a=this._regexMatch(t,e)),a||console&&console.log&&console.log('Translation for "'+t+'" not found in language pack: '+e),a||t):t}return t},t.prototype._regexMatch=function(t,e){var a,n,i,o,r;if(a=this.pack[e].regex)for(n=a.length,i=0;i<n;i++)if((r=(o=a[i])[0].exec(t))&&r[0])return t.split(r[0]).join(o[1]);return""},t.prototype.beforeUpdate=function(t,e){this._fireEvents&&$(this).triggerHandler("beforeUpdate",[t,e,this.pack[t],this.pack[e]])},t.prototype.afterUpdate=function(t,e){this._fireEvents&&$(this).triggerHandler("afterUpdate",[t,e,this.pack[t],this.pack[e]])},t.prototype.refresh=function(){this._fireEvents=!1,this.change(this.currentLang),this._fireEvents=!0},t.prototype._mutation=function(t,e,a){var n=this._mutationCopies[e].apply(t,a),i=this.currentLang,o=$(t);return o.attr("lang")&&(this._fireEvents=!1,this._translateElement(o,this.defaultLang),this.change(this.defaultLang,o),this.currentLang=i,this._processElement(o),this._translateElement(o,this.currentLang)),this._start(o),this.change(this.currentLang,o),this._fireEvents=!0,n},t}();